"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from comfydeploy.models.components import httpmetadata as components_httpmetadata
from comfydeploy.types import BaseModel, Nullable, UNSET_SENTINEL
from comfydeploy.utils import FieldMetadata, PathParamMetadata
import pydantic
from pydantic import model_serializer
from typing import Any, List, Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class GetV1WorkflowsWorkflowIDRequestTypedDict(TypedDict):
    workflow_id: str
    

class GetV1WorkflowsWorkflowIDRequest(BaseModel):
    workflow_id: Annotated[str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))]
    

class GetV1WorkflowsWorkflowIDVersionsTypedDict(TypedDict):
    workflow_id: str
    id: str
    comment: Nullable[str]
    version: float
    snapshot: Nullable[str]
    dependencies: Nullable[str]
    created_at: str
    updated_at: str
    workflow: NotRequired[Any]
    workflow_api: NotRequired[Any]
    

class GetV1WorkflowsWorkflowIDVersions(BaseModel):
    workflow_id: str
    id: str
    comment: Nullable[str]
    version: float
    snapshot: Nullable[str]
    dependencies: Nullable[str]
    created_at: str
    updated_at: str
    workflow: Optional[Any] = None
    workflow_api: Optional[Any] = None
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["workflow", "workflow_api"]
        nullable_fields = ["comment", "snapshot", "dependencies"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
        

class GetV1WorkflowsWorkflowIDResponseBodyTypedDict(TypedDict):
    r"""Specific workflow retrieved successfully"""
    
    name: str
    user_id: str
    id: str
    selected_machine_id: Nullable[str]
    created_at: str
    updated_at: str
    versions: List[GetV1WorkflowsWorkflowIDVersionsTypedDict]
    org_id: NotRequired[str]
    

class GetV1WorkflowsWorkflowIDResponseBody(BaseModel):
    r"""Specific workflow retrieved successfully"""
    
    name: str
    user_id: str
    id: str
    selected_machine_id: Nullable[str]
    created_at: str
    updated_at: str
    versions: List[GetV1WorkflowsWorkflowIDVersions]
    org_id: Optional[str] = None
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["org_id"]
        nullable_fields = ["selected_machine_id"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
        

class GetV1WorkflowsWorkflowIDResponseTypedDict(TypedDict):
    http_meta: components_httpmetadata.HTTPMetadataTypedDict
    object: NotRequired[GetV1WorkflowsWorkflowIDResponseBodyTypedDict]
    r"""Specific workflow retrieved successfully"""
    

class GetV1WorkflowsWorkflowIDResponse(BaseModel):
    http_meta: Annotated[Optional[components_httpmetadata.HTTPMetadata], pydantic.Field(exclude=True)] = None
    object: Optional[GetV1WorkflowsWorkflowIDResponseBody] = None
    r"""Specific workflow retrieved successfully"""
    
